<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         config.php
Description:  Administrative entry point for configuration

*/

    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";
    include "../modules/class_translation.php";
    include "../modules/class_user.php";

    // Check privileges
    check_login();
    if (user_is_customer() == true)
    {
        log_out();
        return;
    }

    if (user_is_reporter() == true || isset($_POST['conf_Cancel']))
    {
        header ('location: ' . $ADMIN_MAIN_SITE);
        return;
    }

    // Edit main config?
    if (isset ($_POST['admin_Config']))
    {
        header('location: ' . $ADMIN_EDITCONFIG_SITE);
        return;
    }
    // Edit system config?
    if (isset ($_POST['admin_System']))
    {
        header('location: ' . $ADMIN_EDITSYSTEM_SITE);
        return;
    }
    // Edit splash page?
    if (isset ($_POST['admin_Splashpage']))
    {
        header ('location: ' . $ADMIN_EDITSPLASHPAGE_SITE);
        return;
    }
    // Edit customer mail?
    if (isset ($_POST['admin_CustMail']))
    {
        header('location: ' . $ADMIN_EDITFILE_SITE . '?filename=' . $CUSTMAIL_CONFIG_FILE);
        return;
    }
    // Edit customer order done mail?
    if (isset ($_POST['admin_CustOrderDoneMail']))
    {
        header('location: ' . $ADMIN_EDITFILE_SITE . '?filename=' . $CUSTORDERDONEMAIL_CONFIG_FILE);
        return;
    }
    // Edit terms of use?
    if (isset ($_POST['admin_Terms']))
    {
        header('location: ' . $ADMIN_EDITFILE_SITE . '?filename=' . $TERMS_CONFIG_FILE . '&use_wysiwyg=' . $ADMIN_USEWYSIGWYG);
        return;
    }
    // Edit imprint?
    if (isset ($_POST['admin_Imprint']))
    {
        header('location: ' . $ADMIN_EDITFILE_SITE . '?filename=' . $IMPRINT_CONFIG_FILE . '&use_wysiwyg=' . $ADMIN_USEWYSIGWYG);
        return;
    }
    // Edit help?
    if (isset ($_POST['admin_Help']))
    {
        header('location: ' . $ADMIN_EDITFILE_SITE . '?filename=' . $HELP_CONFIG_FILE . '&use_wysiwyg=' . $ADMIN_USEWYSIGWYG);
        return;
    }
    // Edit titles?
    if (isset ($_POST['admin_Titles']))
    {
        header('location: ' . $ADMIN_EDITTITLES_SITE);
        return;
    }
    // Edit footer?
    if (isset ($_POST['admin_Footer']))
    {
        header('location: ' . $ADMIN_EDITFOOTER_SITE);
        return;
    }

    // Display
    print_admin_header($cTrans->GetTranslation('admin_config_head'), true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'));
    print_help_link($ADMIN_HELP_FILE . '#n2', $cTrans->GetTranslation('admin_help'));
    echo_r('<form method="post" action="">');
    // Main config
    echo_r('<table border="0" width="100%">');
    echo_r('  <tr>');
    echo_r('    <td width="30%"><input type="submit" class="action_btn" name="admin_Config" value="' . $cTrans->GetTranslation('admin_config_editconfig') . '"></td>');
    echo_r('    <td>' . $cTrans->GetTranslation('admin_config_editconfighint') . '</td>');
    echo_r('  </tr>');
    echo_r('</table>');
    echo_r('<hr>');
    // System config
    if (user_is_admin() == true)
    {
        echo_r('<table border="0" width="100%">');
        echo_r('  <tr>');
        echo_r('    <td width="30%"><input type="submit" class="action_btn" name="admin_System" value="' . $cTrans->GetTranslation('admin_config_editsystem') . '"></td>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_config_editsystemhint') . '</td>');
        echo_r('  </tr>');
        echo_r('</table>');
        echo_r('<hr>');
    }
    // Splash page
    echo_r('<table border="0" width="100%">');
    echo_r('  <tr>');
    echo_r('    <td width="30%"><input type="submit" class="action_btn" name="admin_Splashpage" value="' . $cTrans->GetTranslation('admin_config_editsplashpage') . '"></td>');
    echo_r('    <td>' . $cTrans->GetTranslation('admin_config_editsplashpagehint') . '</td>');
    echo_r('  </tr>');
    echo_r('</table>');
    echo_r('<hr>');
    // Customer mail footer
    echo_r('<table border="0" width="100%">');
    echo_r('  <tr>');
    echo_r('    <td width="30%"><input type="submit" class="action_btn" name="admin_CustMail" value="' . $cTrans->GetTranslation('admin_config_editcustmail') . '"></td>');
    echo_r('    <td>' . $cTrans->GetTranslation('admin_config_editcustmailhint') . '</td>');
    echo_r('  </tr>');
    echo_r('</table>');
    echo_r('<hr>');
    // Customer mail content on order done
    echo_r('<table border="0" width="100%">');
    echo_r('  <tr>');
    echo_r('    <td width="30%"><input type="submit" class="action_btn" name="admin_CustOrderDoneMail" value="' . $cTrans->GetTranslation('admin_config_editcustorderdonemail') . '"></td>');
    echo_r('    <td>' . $cTrans->GetTranslation('admin_config_editcustorderdonemailhint') . '</td>');
    echo_r('  </tr>');
    echo_r('</table>');
    echo_r('<hr>');
    // Terms n conditions
    echo_r('<table border="0" width="100%">');
    echo_r('  <tr>');
    echo_r('    <td width="30%"><input type="submit" class="action_btn" name="admin_Terms" value="' . $cTrans->GetTranslation('admin_config_editterms') . '"></td>');
    echo_r('    <td>' . $cTrans->GetTranslation('admin_config_edittermshint') . '</td>');
    echo_r('  </tr>');
    echo_r('</table>');
    echo_r('<hr>');
    // Imprint
    echo_r('<table border="0" width="100%">');
    echo_r('  <tr>');
    echo_r('    <td width="30%"><input type="submit" class="action_btn" name="admin_Imprint" value="' . $cTrans->GetTranslation('admin_config_editimprint') . '"></td>');
    echo_r('    <td>' . $cTrans->GetTranslation('admin_config_editimprinthint') . '</td>');
    echo_r('  </tr>');
    echo_r('</table>');
    echo_r('<hr>');
    // Help
    echo_r('<table border="0" width="100%">');
    echo_r('  <tr>');
    echo_r('    <td width="30%"><input type="submit" class="action_btn" name="admin_Help" value="' . $cTrans->GetTranslation('admin_config_edithelp') . '"></td>');
    echo_r('    <td>' . $cTrans->GetTranslation('admin_config_edithelphint') . '</td>');
    echo_r('  </tr>');
    echo_r('</table>');
    echo_r('<hr>');
    // Titles
    echo_r('<table border="0" width="100%">');
    echo_r('  <tr>');
    echo_r('    <td width="30%"><input type="submit" class="action_btn" name="admin_Titles" value="' . $cTrans->GetTranslation('admin_config_edittitles') . '"></td>');
    echo_r('    <td>' . $cTrans->GetTranslation('admin_config_edittitleshint') . '</td>');
    echo_r('  </tr>');
    echo_r('</table>');
    echo_r('<hr>');
    // Footer
    echo_r('<table border="0" width="100%">');
    echo_r('  <tr>');
    echo_r('    <td width="30%"><input type="submit" class="action_btn" name="admin_Footer" value="' . $cTrans->GetTranslation('admin_config_editfooter') . '"></td>');
    echo_r('    <td>' . $cTrans->GetTranslation('admin_config_editfooterhint') . '</td>');
    echo_r('  </tr>');
    echo_r('</table>');
    echo_r('<hr>');

    echo_r('</form>');
    print_bottom_links("conf_Cancel", $cTrans->GetTranslation('admin_ok'));
    print_admin_footer();
?>