<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         edit_order.php
Description:  Administrative module to edit orders/delete them

*/

    include "../modules/class_article.php";
    include "../modules/class_order.php";
    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";
    include "../modules/class_translation.php";
    include "../modules/class_textfile.php";

    $cFile = new cTextFile;
    $b_NotFinished = true;
    $b_ErrorOccured = false;
    $artArticle = new cArticle;
    $artArticle->SetFolder($ARTICLE_FOLDER);
    $artArticle->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);
    $ordOrder = new cOrder;
    $ordOrder->SetFolder($ORDER_FOLDER);
    $ordOrder->SetFolderDeleted($ORDER_FOLDER_DELETED);
    $ordOrder->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);
    $ordId = "";
    $ordEdtAction = "edit";
    $errorString = "";

    // Check privileges
    check_login();
    if (user_is_customer() == true)
    {
        log_out();
        return;
    }

    // Check action
    if (isset ($_POST['ord_EdtAction']) == true)
    {
        if ($_POST['ord_EdtAction'] == "delete")
            $ordEdtAction = "delete";
    }
    else if (isset ($_GET['action']) == true)
    {
        if ($_GET['action'] == "delete")
            $ordEdtAction = "delete";
    }

    if (isset ($_POST['ord_Id']) == true)
        $ordId = $_POST['ord_Id'];
    else if (isset ($_GET['id']) == true)
        $ordId = $_GET['id'];
    if ($ordOrder->LoadOrderFromId($ordId) == false)
    {
        print_error_message($cTrans->GetTranslation('admin_ordedt_errorload') . ' ' . $ordId);
        return;
    }

    // Order edit cancelled?
    if (isset ($_POST['ord_Cancel']))
    {
        header ('Location: ' . $ADMIN_ORDLIST_SITE);
        return;
    }

    // Save the order
    if (isset ($_POST['ord_Save']))
    {
        // Order set to done?
        if (isset ($_POST['ord_done']))
            $ordOrder->SetDone($_POST['ord_done'] == 1);
        else
            $ordOrder->SetDone(false);
            
        if ($ordOrder->SaveOrder() == false)
            $errorString = $cTrans->GetTranslation('admin_ordedt_errorsave') . ' ' . $ordId;
        else
        {
            // Inform the customer as well?
            if ($_POST['ord_done'] == 1 && $SHOP_CUSTOMERORDERDONEEMAIL == true)
            {
                $ordOrder->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);
                $aTranslations = array();
                $aTranslations['title'] = $SHOP_TITLE . ' - ' . $cTrans->GetTranslation('admin_order_custmailtitle');
                $aTranslations['articles'] = $cTrans->GetTranslation('admin_order_custmailarticle');
                $aTranslations['name'] = $cTrans->GetTranslation('admin_order_custmailname');
                $aTranslations['count'] = $cTrans->GetTranslation('admin_order_custmailcount');
                $aTranslations['price'] = $cTrans->GetTranslation('admin_order_custmailprice');
                $aTranslations['userdef'] = $cTrans->GetTranslation('admin_order_custmailuserdef');
                $aTranslations['shiptype'] = $cTrans->GetTranslation('admin_order_custmailshiptype');
                $aTranslations['totalprice'] = $cTrans->GetTranslation('admin_order_custmailtotalprice');

                $ordOrder->SendCustomerOrder($ordOrder->GetEmail(), $SHOP_TITLE . '<' . $SHOP_ORDEREMAIL . '>', $aTranslations, $ARTICLE_FOLDER, $cFile->LoadFromFile($CUSTORDERDONEMAIL_CONFIG_FILE), $SHOP_CURRENCY, $MAIL_FOLDER);
                // Send a copy to the administrator email?
                if ($ADMIN_MAILON_AUTOCUSTEMAIL == true)
                    $ordOrder->SendCustomerOrder($ADMIN_EMAIL, $SHOP_TITLE . '<' . $SHOP_ORDEREMAIL . '>', $aTranslations, $ARTICLE_FOLDER, $cFile->LoadFromFile($CUSTORDERDONEMAIL_CONFIG_FILE), $SHOP_CURRENCY, $MAIL_FOLDER);
            }
            log_message ('User ' . get_user_name() . ' saved order ' . $ordOrder->GetId());
            header('location: ' . $ADMIN_ORDLIST_SITE);
            return;
        }
    }

    // Delete the order
    if (isset ($_POST['ord_Delete']))
    {
        if ($ordOrder->DeleteOrderFinal() == false)
            $errorString = $cTrans->GetTranslation('admin_ordedt_errordelete') . ' ' . $ordIdd;
        else
        {
            log_message ('User ' . get_user_name() . ' deleted order' . $ordOrder->GetId());
            header('location: ' . $ADMIN_ORDLIST_SITE);
            return;
        }
    }

    // Display the input dialog for edit order
    $titleString = $cTrans->GetTranslation('admin_ordedt_deletehead');
    if ($ordEdtAction == "edit")  // Edit
        $titleString = $cTrans->GetTranslation('admin_ordedt_edithead');
    print_admin_header($titleString, true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'),
                       $ADMIN_ORDLIST_SITE, $cTrans->GetTranslation('admin_ordl_button'));
    print_help_link($ADMIN_HELP_FILE . '#n1-3', $cTrans->GetTranslation('admin_help'));
    if ($errorString != "")
        print_error_message($errorString);
        
    if ($ordEdtAction == "delete")
    {
        echo_r($cTrans->GetTranslation('admin_ordedt_deletequest') . ':<br>');
    }
    // Order
    echo_r('<form action="' . $_SERVER['PHP_SELF'] . '" method="post" enctype="multipart/form-data">');
    echo_r('<table width="100%">');
    echo_r('<tr>');
    echo_r('  <td width="30%">' . $cTrans->GetTranslation('admin_ord_id') . ':</td>');
    echo_r('  <td>' . $ordOrder->GetId() . '</td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td>' . $cTrans->GetTranslation('admin_ord_date') . ':</td>');
    echo_r('  <td>' . $ordOrder->GetDate() . '</td>');
    echo_r('</tr>');
    echo_r('</table>');
    // Address
    echo_r('<hr>');
    echo_r('<table width="100%">');
    echo_r('<tr>');
    echo_r('  <td width="30%">' . $cTrans->GetTranslation('admin_ord_address') . ':</td>');
    echo_r('  <td></td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td>' . $cTrans->GetTranslation('admin_usr_firstname') . ':</td>');
    echo_r('  <td>' . $ordOrder->GetFirstName() . '</td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td>' . $cTrans->GetTranslation('admin_usr_lastname') . ':</td>');
    echo_r('  <td>' . $ordOrder->GetLastName() . '</td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td>' . $cTrans->GetTranslation('admin_usr_street') . ':</td>');
    echo_r('  <td>' . $ordOrder->GetStreet() . ' ' . $ordOrder->GetStreetNo() . '</td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td>' . $cTrans->GetTranslation('admin_usr_city') . ':</td>');
    echo_r('  <td>' . $ordOrder->GetCity() . '</td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td>' . $cTrans->GetTranslation('admin_usr_zipcode') . ':</td>');
    echo_r('  <td>' . $ordOrder->GetZipCode() . '</td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td>' . $cTrans->GetTranslation('admin_usr_land') . ':</td>');
    echo_r('  <td>' . $ordOrder->GetLand() . '</td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td>' . $cTrans->GetTranslation('admin_usr_phoneno') . ':</td>');
    echo_r('  <td>' . $ordOrder->GetTelephoneNo() . '</td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td>' . $cTrans->GetTranslation('admin_usr_email') . ':</td>');
    echo_r('  <td>' . $ordOrder->GetEmail() . '</td>');
    echo_r('</tr>');
    echo_r('</table>');
    // Articles
    echo_r('<hr>');
    echo_r('<table width="100%">');
    echo_r('<tr>');
    echo_r('  <td width="30%">' . $cTrans->GetTranslation('admin_ord_article') . ':</td>');
    echo_r('  <td></td>');
    echo_r('</tr>');
    $ordCount = 0;
    $ordValue = 0;
    $aIds = $ordOrder->GetArticleIds();
    $aNames = $ordOrder->GetArticleNames();
    $aPrices = $ordOrder->GetArticlePrices();
    $aCounts = $ordOrder->GetArticleCounts();
    $aAddToPrices = $ordOrder->GetArticleAddToPrices();
    $bLoaded = false;
    for ($i = 0; $i < count($aIds); $i ++)
    {
        $bLoaded = $artArticle->LoadArticleFromId($aIds[$i]);
        echo_r('<tr>');
        echo_r('  <td>#' . ($i + 1) . ':</td>');
        if ($bLoaded == true) // Article does exist
            echo_r('  <td><img src="' . $artArticle->GetImgThumbUrl() . '" width="' . $THUMB_IMAGE_WIDTH .'" height="' . $THUMB_IMAGE_HEIGHT . '" alt=""></td>');
        else // might be deleted
            echo_r('  <td><img src="' . $ERROR_IMAGE . '" alt=""></td>');
        echo_r('</tr>');
        echo_r('<tr>');
        echo_r('  <td>' . $cTrans->GetTranslation('admin_art_id') . ':</td>');
        echo_r('  <td>' . $aIds[$i] . '</td>');
        echo_r('</tr>');
        echo_r('<tr>');
        echo_r('  <td>' . $cTrans->GetTranslation('admin_art_name') . ':</td>');
        echo_r('  <td>' . $aNames[$i] . '</td>');
        echo_r('</tr>');
        echo_r('<tr>');
        echo_r('  <td>' . $cTrans->GetTranslation('admin_art_price') . ':</td>');
        echo_r('  <td>' . format_price($aPrices[$i] + $aAddToPrices[$i]) . ' ' . $SHOP_CURRENCY . '</td>');
        echo_r('</tr>');
        echo_r('<tr>');
        echo_r('  <td>' . $cTrans->GetTranslation('admin_ord_count') . ':</td>');
        echo_r('  <td>' . $aCounts[$i] . '</td>');
        $ordCount += $aCounts[$i];
        $ordValue += ($aCounts[$i] * ($aPrices[$i] + $aAddToPrices[$i]));
        echo_r('</tr>');
        // Custom fields
        echo_r('<tr>');
        echo_r('  <td>' . $cTrans->GetTranslation('admin_ordedt_userdef') . ':</td>');
        $aCNames = $ordOrder->GetArticleCustNames($i);
        $aCFields = $ordOrder->GetArticleCustFields($i);
        echo_r ('  <td>');
        for ($v = 0; $v < $ARTICLE_CUSTOM_FIELD_COUNT; $v ++)
        {
            if ($aCNames[$v] != "")
                echo_r ($aCNames[$v] . '=' . $aCFields[$v] . '<br>');
        }
        echo_r ('  </td>');
        echo_r('</tr>');
    }
    echo_r('</table>');

    // Summary
    echo_r('<hr>');
    echo_r('<table width="100%">');
    echo_r('<tr>');
    echo_r('  <td width="30%">' . $cTrans->GetTranslation('admin_ord_count') . ':</td>');
    echo_r('  <td>' . $ordCount . '</td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td>' . $cTrans->GetTranslation('admin_ordedt_shiptype') . ':</td>');
    echo_r('  <td>' . $ordOrder->GetShippingType() . '</td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td>' . $cTrans->GetTranslation('admin_ordedt_shipcost') . ':</td>');
    echo_r('  <td>' . format_price($ordOrder->GetShippingCost()) . ' ' . $SHOP_CURRENCY . '</td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td>' . $cTrans->GetTranslation('admin_ord_value') . ':</td>');
    echo_r('  <td>' . format_price($ordValue) . ' + ' . format_price($ordOrder->GetShippingCost()) . ' = ' . format_price($ordValue + $ordOrder->GetShippingCost()) . ' ' . $SHOP_CURRENCY . '</td>');
    echo_r('</tr>');
    echo_r('<tr>');
    echo_r('  <td width="30%">' . $cTrans->GetTranslation('admin_ord_state') . ':</td>');
    if ($ordEdtAction == "edit")  // Edit
    {
        echo_r('  <td>');
        echo_r('    <select name="ord_done">');
        echo ('      <option value="1"');
        if ($ordOrder->IsDone() == true)
            echo (' selected');
        echo_r('>' . $cTrans->GetTranslation('admin_ord_statedone') . '</option>');
        echo ('      <option name="0"');
        if ($ordOrder->IsDone() == false)
            echo (' selected');
        echo_r('>' . $cTrans->GetTranslation('admin_ord_stateundone') . '</option>');
        echo_r('    </select>');
        echo_r('  </td>');
    }
    else  // Delete
    {
        if ($ordOrder->IsDone() == false)
            echo_r('<td>' . $cTrans->GetTranslation('admin_ord_stateundone') . '</td>');
        else
            echo_r('<td>' . $cTrans->GetTranslation('admin_ord_statedone') . '</td>');
    }
    echo_r('</tr>');
    echo_r('</table>');
    if ($ordEdtAction == "edit")  // Edit
        print_bottom_links("ord_Save", $cTrans->GetTranslation('admin_save'),
                           "ord_Cancel", $cTrans->GetTranslation('admin_cancel'), false);
    else // Delete
        print_bottom_links("ord_Delete", $cTrans->GetTranslation('admin_yes'),
                           "ord_Cancel", $cTrans->GetTranslation('admin_cancel'), false);
    echo_r('<input type="hidden" name="ord_Id" value="' . $ordId . '">');
    echo_r('<input type="hidden" name="ord_EdtAction" value="' . $ordEdtAction . '">');
    echo_r('</form>');

    print_admin_footer();

?>