<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         list_category.php
Description:  Administrative overview of all categories

*/

    include "../modules/class_category.php";
    include "../modules/class_categorylist.php";
    include "../modules/class_translation.php";
    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";

    // Check privileges
    check_login();
    if (user_is_customer() == true)
    {
        log_out();
        return;
    }
    if (isset ($_POST['catl_Cancel']))
    {
        header('location: ' . $ADMIN_MAIN_SITE);
        return;
    }

    // Create new category?
    if (isset ($_POST['catl_CreateCategory']))
    {
        header ('Location: ' . $ADMIN_CATEDT_SITE . '?action=new');
        return;
    }
    // Edit category?
    if (isset ($_POST['catl_EditCategory']))
    {
        header ('Location: ' . $ADMIN_CATEDT_SITE . '?id=' . $_POST['catl_CatId'] . '&action=edit');
        return;
    }
    // Delete category?
    if (isset ($_POST['catl_DeleteCategory']))
    {
        header ('Location: ' . $ADMIN_CATMOD_SITE . '?id=' . $_POST['catl_CatId'] . '&action=delete');
        return;
    }
    // Lock category?
    if (isset ($_POST['catl_LockCategory']))
    {
        header ('Location: ' . $ADMIN_CATMOD_SITE . '?id=' . $_POST['catl_CatId'] . '&action=lock');
        return;
    }
    // Unlock category?
    if (isset ($_POST['catl_UnlockCategory']))
    {
        header ('Location: ' . $ADMIN_CATMOD_SITE . '?id=' . $_POST['catl_CatId'] . '&action=unlock');
        return;
    }

    // Display
    print_admin_header($cTrans->GetTranslation('admin_catl_head'), true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'));
    print_help_link($ADMIN_HELP_FILE . '#n1-2', $cTrans->GetTranslation('admin_help'));
    $cat = new cCategory;
    $catList = new cCategoryList;
    $catFilter = $FILTER_ALL;
    if (isset ($_GET['filter']) && $_GET['filter'] != "")
        $catFilter = $_GET['filter'];
    else if (isset ($_POST['catl_filter']) && $_POST['catl_filter'] != "")
        $catFilter = $_POST['catl_filter'];

    $cat->SetFolder($CATEGORY_FOLDER);
    $catList->SetFolder($CATEGORY_FOLDER);

    $catList->LoadCategoryList($catFilter);
    $list = $catList->GetCategoryList();
//    rsort($list);

    echo_r ('<form method="post" action="">');
    echo_r ('<table border="0" width="100%">');
    echo_r ('<tr>');
    echo_r ('  <td width="20%"><input type="submit" class="bottom_btn" value="' . $cTrans->GetTranslation('admin_catl_createnew') . '" name="catl_CreateCategory"></td>');
    echo_r ('  <td width="10%">Filter</td>');
    echo_r ('  <td>');
    echo_r ('  <select name="catl_filter" onChange="submit();">');
    echo   ('  <option value="' . $FILTER_ALL . '"');
    if ($catFilter == $FILTER_ALL)
        echo (' selected');
    echo_r ('>' . $cTrans->GetTranslation('admin_all') . '</option>');
    echo   ('  <option value="' . $FILTER_UNLOCKED . '"');
    if ($catFilter == $FILTER_UNLOCKED)
        echo (' selected');
    echo_r ('>' . $cTrans->GetTranslation('admin_unlocked') . '</option>');
    echo   ('  <option value="' . $FILTER_LOCKED . '"');
    if ($catFilter == $FILTER_LOCKED)
        echo (' selected');
    echo_r ('>' . $cTrans->GetTranslation('admin_locked') . '</option>');
    echo_r ('  </select>');
    echo_r ('  </td>');
    echo_r ('</tr>');
    echo_r ('</table>');
    echo_r ('</form>');

    foreach ($list as $value)
    {
        $cat->LoadCategoryFromId($value);

        echo_r('<hr>');
        echo_r('<table width="100%" border="0">');
        echo_r('  <tr>');
        echo_r('    <td width="16%">');
        echo  ('      <a href="' . $ADMIN_CATEDT_SITE . '?id=' . $cat->GetId() . '&amp;action=edit">');
        echo_r('<img src="' . $CATEGORY_IMAGE . '" title="' . $cTrans->GetTranslation('admin_edit') . '" alt=""></a>');
        if ($cat->IsLocked() == true)
            echo_r('       <img src="' . $LOCKED_IMAGE . '" title="' . $cTrans->GetTranslation('admin_locked') . '" alt="">');
        echo_r('    </td>');
        echo_r('    <td width="27%">');
        echo_r('       ' . $cTrans->GetTranslation('admin_cat_id') . ': ' . $cat->GetId() . '<br>');
        echo_r('       ' . $cTrans->GetTranslation('admin_cat_date') . ': ' . $cat->GetDate());
        echo_r('    </td>');
        echo_r('    <td width="27%">');
        echo_r('       ' . $cTrans->GetTranslation('admin_cat_name') . ': ' . $cat->GetName() . '<br>');
        echo_r('       ' . $cTrans->GetTranslation('admin_cat_position') . ': ' . $cat->GetPosition());
        echo_r('    </td>');
        echo_r('    <td width="30%">');
        echo_r('    <form method="post" action="">');
        echo_r('    <input type="hidden" value="' . $cat->GetId() . '" name="catl_CatId">  ');
        echo_r('    <input type="submit" class="side_btn" value="' . $cTrans->GetTranslation('admin_edit') . '" name="catl_EditCategory">  ');
        if ($cat->IsLocked() == true)
        {
            echo_r('    <input type="submit" class="side_btn" value="' . $cTrans->GetTranslation('admin_unlock') . '" name="catl_UnlockCategory">  ');
        }
        else
        {
            echo_r('    <input type="submit" class="side_btn" value="' . $cTrans->GetTranslation('admin_lock') . '" name="catl_LockCategory">  ');
        }
        if (user_is_reporter() == false)
            echo_r('    <input type="submit"  class="side_btn" value="' . $cTrans->GetTranslation('admin_delete') . '" name="catl_DeleteCategory">  ');
        echo_r('    </form>');
        echo_r('    </td>');
        echo_r('  </tr>');
        echo_r('</table>');
    }
    print_bottom_links("catl_Cancel", $cTrans->GetTranslation('admin_ok'));

    print_admin_footer();
?>