<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         reset_statistics.php
Description:  Administrative module reset statistics

*/

    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";
    include "../modules/class_translation.php";
    include "../modules/class_articlelist.php";
    include "../modules/class_textfile.php";

    $errorMessage = "";
    
    // Check privileges
    check_login();
    if (user_is_customer() == true)
    {
        log_out();
        return;
    }
    if (user_is_admin() == false)
    {
        header('location: ' . $ADMIN_MAIN_SITE);
        return;
    }

    // Cancel reset?
    if (isset($_POST['resetStat_Cancel']))
    {
        header('location: ' . $ADMIN_MAIN_SITE);
        return;
    }

    // Do reset?
    if (isset($_POST['resetStat_Save']))
    {
        $cFile = new cTextFile;
        // Article stat reset?
        if (isset($_POST['resetstat_articles']) == true && $_POST['resetstat_articles'] == "1")
        {
            $artList = new cArticleList;
            $artList->SetFolder($ARTICLE_FOLDER);
            $artList->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);
            $artList->ResetArticleStatistics();
            log_message ('User ' . get_user_name() . ' cleared article statistic');
        }
        if (isset($_POST['resetstat_frontend']) == true && $_POST['resetstat_frontend'] == "1")
        {
            copy ($SHOP_COUNT, $ADMIN_LOG_ARCHIVE . 'r_' . date("Ymd_His_") . basename($SHOP_COUNT));
            $cFile->SaveToFile($SHOP_COUNT, "0");
            copy ($SHOP_COUNT_LOG, $ADMIN_LOG_ARCHIVE . 'r_' . date("Ymd_His_") . basename($SHOP_COUNT_LOG));
            $cFile->SaveToFile($SHOP_COUNT_LOG, "");
            copy ($SHOP_COUNT_IPADDR, $ADMIN_LOG_ARCHIVE . 'r_' . date("Ymd_His_") . basename($SHOP_COUNT_IPADDR));
            $cFile->SaveToFile($SHOP_COUNT_IPADDR, "");
            log_message ('User ' . get_user_name() . ' cleared frontend statistic');
        }
        if (isset($_POST['resetstat_backend']) == true && $_POST['resetstat_backend'] == "1")
        {
            copy ($ADMIN_LOG_FILE, $ADMIN_LOG_ARCHIVE . 'r_' . date("Ymd_His_") . basename($ADMIN_LOG_FILE));
            $cFile->SaveToFile($ADMIN_LOG_FILE, "");
            log_message ('User ' . get_user_name() . ' cleared backend statistic');
        }
        header('location: ' . $ADMIN_MAIN_SITE);
        return;
    }

    // Display
    print_admin_header($cTrans->GetTranslation('admin_resetstat_head'), true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'));
    print_help_link($ADMIN_HELP_FILE . '#n1-12', $cTrans->GetTranslation('admin_help'));
    if ($errorMessage != "")
        print_error_message($errorMessage);
        
    echo_r ('<form method="post" action="">');

    // Newsletter content
    echo_r ('<table border="0" width="100%">');
    echo_r ('  <tr>');
    echo_r ('    <td width="5%"><input type="checkbox" name="resetstat_articles" value="1"></td>');
    echo_r ('    <td>' . $cTrans->GetTranslation('admin_resetstat_articlestats') . '</td>');
    echo_r ('  </tr>');
    echo_r ('  <tr>');
    echo_r ('    <td width="5%"><input type="checkbox" name="resetstat_frontend" value="1"></td>');
    echo_r ('    <td>' . $cTrans->GetTranslation('admin_resetstat_frontendstats') . '</td>');
    echo_r ('  </tr>');
    echo_r ('  <tr>');
    echo_r ('    <td width="5%"><input type="checkbox" name="resetstat_backend" value="1"></td>');
    echo_r ('    <td>' . $cTrans->GetTranslation('admin_resetstat_backendstats') . '</td>');
    echo_r ('  </tr>');
    echo_r ('</table>');

    echo_r('<br>');

    print_bottom_links("resetStat_Save", $cTrans->GetTranslation('admin_save'), "resetStat_Cancel", $cTrans->GetTranslation('admin_cancel'), false);
    echo_r('</form>');

    print_admin_footer();
?>