<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         mod_admin.php
Description:  Functions for the administrative area

*/

    include "mod_constants.php";
    include "class_count.php";
    include "class_mail.php";
    include "class_translation.php";

    $cTrans = new cTranslation;
    $cTrans->SetTranslationFile($ADMIN_LANGUAGE_FILE);

    // functions
    function print_admin_header($titleString, $printLogout = false, $logoutString = "", $backLink = true, $backString = "", $backLink2 = "", $backString2 = "", $finish = true)
    {
        global $ADMIN_HEADER_IMAGE;
        global $ADMIN_MAIN_SITE;
        global $SHOP_TITLE;
        global $ADMIN_SESS_USER;
        global $SHOP_CHARSET_FORMAT;

        ini_set("default_charset", $SHOP_CHARSET_FORMAT);

        // Init session before HTML output!!
        echo_r ('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">');
        echo_r ('<html>');
        echo_r ('<head><title>' . $SHOP_TITLE . ' Administration ' . $titleString . '</title>');
        echo_r ('<link rel=stylesheet type="text/css" href="../config/admin.css">');
        echo_r ('<link rel="shortcut icon" type="image/x-icon" href="../images/ico_favicon.ico">');
        echo_r ('<meta name="description" content="' . $SHOP_TITLE . ' - Administration">');
        echo_r ('<meta name="author" content="Alternate Tools">');
        echo_r ('<meta name="robots" content="noindex, nofollow">');
        echo_r ('<meta http-equiv="Content-Type" content="text/html; charset=' . $SHOP_CHARSET_FORMAT . '">');
        if ($finish == true)
            finish_admin_header($titleString, $printLogout, $logoutString, $backLink, $backString, $backLink2, $backString2);
    }
    
    function print_wysiwyg_header()
    {
        global $SHOP_LANGUAGE;
        global $ADMIN_EDITOR_FILE;
//        global $PAGEIMAGES_LIST;

        echo_r ('<script type="text/javascript" src="' . $ADMIN_EDITOR_FILE . '"></script>');
        echo_r ('<script type="text/javascript">');
	    echo_r ('tinyMCE.init({');
	    echo_r ('// General options');
	    echo_r ('mode : "textareas",');
	    echo_r ('theme : "advanced",');
	    if ($SHOP_LANGUAGE == "de")
	    echo_r ('language : "de",');
	    echo_r ('plugins : "autolink,lists,pagebreak,layer,table,advhr,advimage,advlink,iespell,inlinepopups,insertdatetime,preview,searchreplace,contextmenu,paste,directionality,fullscreen,noneditable,nonbreaking,xhtmlxtras,template,wordcount,advlist",');
	    echo_r ('// Image list - machine generated');
//        echo_r ('external_image_list_url : "' . $PAGEIMAGES_LIST . '",');
	    echo_r ('// Theme options');
	    echo_r ('theme_advanced_buttons1 : "bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,formatselect,fontselect,fontsizeselect",');
	    echo_r ('theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",');
	    echo_r ('theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,print,|,ltr,rtl,|,fullscreen",');
	    echo_r ('theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,template,pagebreak,restoredraft",');
	    echo_r ('theme_advanced_toolbar_location : "top",');
	    echo_r ('theme_advanced_toolbar_align : "left",');
	    echo_r ('theme_advanced_statusbar_location : "bottom",');
	    echo_r ('theme_advanced_resizing : true,');
	    echo_r ('// Content CSS');
	    echo_r ('content_css : "../config/editor.css"');
	    echo_r ('});');
	    echo_r ('</script>');
    }

    function finish_admin_header($titleString, $printLogout = false, $logoutString = "", $backLink = true, $backString = "", $backLink2 = "", $backString2 = "")
    {
        global $ADMIN_HEADER_IMAGE;
        global $ADMIN_MAIN_SITE;
        global $SHOP_TITLE;
        global $ADMIN_SESS_USER;
        global $SITE_CHARSET_FORMAT;

        echo_r ('</head>');
        echo_r ('<body>');
        echo_r ('<center>');
        echo_r ('<div class="admin_outer_div">');
        echo_r ('<div class="admin_logo_div">');
 //       if ($backLink == true)
   //           echo_r ('   <a href="' . $ADMIN_MAIN_SITE . '">');
        if ($backLink == true)
            echo_r ('  <img border="0" src="'. $ADMIN_HEADER_IMAGE .'" alt="' . $SHOP_TITLE . '" style="cursor: pointer;" onClick="JavaScript:window.location.href=\'' . $ADMIN_MAIN_SITE . '\'">');
        else
            echo_r ('  <img border="0" src="'. $ADMIN_HEADER_IMAGE .'" alt="' . $SHOP_TITLE . '">');
   //       if ($backLink == true)
   //           echo_r ('   </a>');
        echo_r ('</div>');
        echo_r ('<div class="admin_top_div">');
        echo_r ('<form method="post" action="">');
        echo_r ('  <div class="admin_top_side_div">');
        echo_r ('    <div class="admin_top_side_content_div">');
        if ($backLink == true && $backString != "")
        {
            echo_r ('      <input class="action_btn" type="button" name="admin_Main" value="' . $backString . '" onClick="JavaScript:window.location.href=\'' . $ADMIN_MAIN_SITE . '\'">');
            if ($backLink2 != "" && $backString2 != "")
                echo_r ('      <input class="action_btn" type="button" name="admin_Prev" value="' . $backString2 . '" onClick="JavaScript:window.location.href=\'' . $backLink2 . '\'">');
        }
        echo_r ('    </div>');
        echo_r ('  </div>');
        echo_r ('  <div class="admin_top_middle_div">');
        echo_r ('    <div class="admin_top_middle_content_div"><b>' . $SHOP_TITLE . ': Administration' . $titleString . '</b></div>');
        echo_r ('  </div>');
        echo_r ('  <div class="admin_top_side_div">');
        echo_r ('    <div class="admin_top_side_content_div">');
        if ($printLogout == true)
        {
            echo_r('      <input class="action_btn" type="submit" name="admin_Logout" value="' . $logoutString . ' [' . $_SESSION[$ADMIN_SESS_USER] . ']">');
        }
        echo_r ('    </div>');
        echo_r ('  </div>');
        echo_r ('</form>');
        echo_r ('</div>');
        echo_r ('<div class="admin_clear_float"></div>');
    }

    function print_help_link($linkUrl, $strString)
    {
        echo_r ('<table width="100%" border="0">');
        echo_r ('  <tr><td style="text-align: right">');
        echo_r ('    <a href="' . $linkUrl . '" target="_blank"><b>' . $strString . '</b></a>');
        echo_r ('  </td></tr>');
        echo_r ('</table>');
    }

    function print_bottom_links($nameLeft, $valueLeft, $nameRight = "", $valueRight = "", $withForm = true)
    {
        echo_r ('<div class="admin_bottom_spacer"></div>');
        if ($withForm == true)
            echo_r ('<form method="post" action="">');
        echo_r ('<div class="admin_bottom_div">');
        echo_r ('  <div class="admin_bottom_content_div">');
        echo_r ('    <input type="submit" class="action_btn" name="' . $nameLeft . '" value="' . $valueLeft . '">');
        if ($nameRight != "")
            echo_r ('    <input type="submit" class="action_btn" name="' . $nameRight . '" value="' . $valueRight . '">');
        echo_r ('  </div>');
        echo_r ('</div>');
        if ($withForm == true)
            echo_r ('</form>');
    }

    function print_admin_footer()
    {
        echo_r ('</div>');
        echo_r ('</center>');
        echo_r ('</body>');
        echo_r ('</html>');
    }
    
    function print_error_message($msgString)
    {
        global $ERROR_IMAGE;

        echo_r ('  <div class="admin_error_div">');
        echo_r ('    <div class="admin_error_content_div">');
        echo_r ('      <b>- ' . $msgString . '</b>');
        echo_r ('    </div>');
        echo_r ('  </div>');
    }
    
    function log_in($userName, $userType)
    {
        global $ADMIN_SESS_USER;
        global $ADMIN_SESS_TYPE;
        
        session_start();
        $_SESSION[$ADMIN_SESS_USER] = $userName;
        $_SESSION[$ADMIN_SESS_TYPE] = $userType;
    }
    
    function log_out()
    {
        global $ADMIN_LOGIN_SITE;
        session_unset();
        session_destroy();
        header ('location: '. $ADMIN_LOGIN_SITE);
    }
    
    function get_user_name()
    {
        global $ADMIN_SESS_USER;
        return $_SESSION[$ADMIN_SESS_USER];
    }
    
    function check_login()
    {
        global $ADMIN_LOGIN_SITE;
        global $ADMIN_SESS_USER;
        global $ADMIN_SESS_TYPE;

        session_start();
        if (isset($_SESSION[$ADMIN_SESS_USER]) == false || $_SESSION[$ADMIN_SESS_USER] == "" || isset($_SESSION[$ADMIN_SESS_TYPE]) == false || $_SESSION[$ADMIN_SESS_TYPE] == "")
            header ('location: ' . $ADMIN_LOGIN_SITE);
        if (isset($_POST['admin_Logout']))
        {
            log_message ('User ' . get_user_name() . ' logged out');
            log_out();
        }
    }
    
    function get_auth()
    {
        global $ADMIN_SESS_TYPE;
        if ($_SESSION[$ADMIN_SESS_TYPE] == "")
            return -1;
        return $_SESSION[$ADMIN_SESS_TYPE];
    }
    
    function user_is_customer()
    {
        global $USERTYPE_REPORTER;
        return (get_auth() < $USERTYPE_REPORTER);
    }
    function user_is_reporter()
    {
        global $USERTYPE_REPORTER;
        return (get_auth() == $USERTYPE_REPORTER);
    }
    function user_is_admin()
    {
        global $USERTYPE_ADMINISTRATOR;
        return (get_auth() == $USERTYPE_ADMINISTRATOR);
    }
    
    function retrieve_extension($fileName)
    {
        $iCount = 0;
        for ($i = strlen($fileName) - 1; $i >= 0; $i --)
        {
            $iCount ++;
            if ($fileName[$i] == '.')
            {
                return substr($fileName, -$iCount);
            }
        }
        return $fileName;
    }
    function retrieve_absolute_path($fileName)
    {
        if (substr($fileName, 0, 3) == "../")
            return substr($fileName, 4);
        return $fileName;
    }
    
    function check_image_extension($fileName)
    {
        $fileExt = strtolower(retrieve_extension($fileName));
        if ($fileExt != ".gif" && $fileExt != ".jpg" && $fileExt != ".jpeg" && $fileExt != ".png")
            return false;
        
        return true;
    }
    
    function resize_image($srcName, $tmpName, $destName, $imgDestWidth, $imgDestHeight, $noResize = false)
    {
        // Check, if resize is necessary
        $sizes = getimagesize($tmpName);
        $srcWidth = $sizes[0];
        $srcHeight = $sizes[1];
        // Just copy?
        if (($srcWidth == $imgDestWidth && $srcHeight == $imgDestHeight) || $noResize == true)
        {
            return @ copy ($tmpName, $destName);
        }
        // Resize it...
        $imgSrcExt = strtolower(retrieve_extension($srcName));
        // Load source image
        if ($imgSrcExt == ".jpg" || $imgSrcExt == ".jpeg")
            $imgSrc = imagecreatefromjpeg($tmpName);
        else if ($imgSrcExt == ".png")
            $imgSrc = imagecreatefrompng($tmpName);
        else if ($imgSrcExt == ".gif")
            $imgSrc = imagecreatefromgif($tmpName);
        else
            return false;  // unknown image type!!

        //Calculate the image ratio
        log_message ('User ' . get_user_name() . ' image upload must be resized to ' . $imgDestWidth . ' x ' . $imgDestHeight . ' - origin: ' . $srcWidth . ' x ' . $srcHeight);
        $imgRatio = ($srcWidth / $srcHeight);
        if ($imgRatio > 1)
        {
            $newWidth = $imgDestWidth;
            $newHeight = ($imgDestWidth / $imgRatio);
        }
        else
        {
            $newHeight = $imgDestHeight;
            $newWidth = ($imgDestHeight * $imgRatio);
        }
        $newImage = imagecreatetruecolor($imgDestWidth, $imgDestHeight);
        // Use a white background, default is black....
        $fillColor = ImageColorAllocate ($newImage, 255, 255, 255);
        imagefill($newImage, 1, 1, $fillColor);  // Does not work on PHP 5.3??
        imagefilledrectangle($newImage, 0, 0, $imgDestWidth, $imgDestHeight, $fillColor);
        if ($newHeight != $imgDestHeight)  // center horizontal
            ImageCopyResized($newImage, $imgSrc, 0, ($imgDestHeight - $newHeight) / 2, 0, 0, $newWidth, $newHeight, $srcWidth, $srcHeight);
        else  // center vertical
            ImageCopyResized($newImage, $imgSrc, ($imgDestWidth - $newWidth) / 2, 0, 0, 0, $newWidth, $newHeight, $srcWidth, $srcHeight);
        //Save the target image
        if ($imgSrcExt == ".jpg" || $imgSrcExt == ".jpeg")
            imagejpeg($newImage, $destName);
        if ($imgSrcExt == ".png")
            imagepng($newImage, $destName);
        if ($imgSrcExt == ".gif")
            imagegif($newImage, $destName);
        ImageDestroy($newImage);
        ImageDestroy($imgSrc);
        return true;
    }
    
    function reset_folder($srcFolder, $destFolder)
    {
        $rDir = dir($destFolder);
        $strEntry = "";
        while (false !== ($strEntry = $rDir->read()))
        {
//            echo "delete: ". $destFolder . $strEntry . "<br>";
            if (file_exists($destFolder . $strEntry) == true)
                unlink ($destFolder . $strEntry);
        }
        $rDir = dir($srcFolder);
        $strEntry = "";
        while (false !== ($strEntry = $rDir->read()))
        {
//            echo "copy: ". $srcFolder . $strEntry . " - ". $destFolder . basename($strEntry) . "<br>";
            @copy ($srcFolder . $strEntry, $destFolder . basename($strEntry));
        }
    }
    
    function echo_r($strString)
    {
        echo ($strString . chr(13));
    }
    
    function format_price($priceString)
    {
        return sprintf("%01.2f", $priceString);
    }

    function log_message($messageText)
    {
       global $ADMIN_LOG_FILE;
       global $ADMIN_LOG_ARCHIVE;
       global $MAX_LOG_SIZE;
       
	   $count = new class_counter;
       $count->set_files("", $ADMIN_LOG_FILE, "", $ADMIN_LOG_ARCHIVE);   // logging only
	   $count->set_max_logsize($MAX_LOG_SIZE);
	   $count->set_count_log(false, true);  // logging only
	   $count->increase($messageText);
    }
    
    function correct_decimal_seperator($strString)
    {
        return $strString = str_replace(',', '.', $strString);
    }
    
    function sort_table($tableData, $sortColumn, $sortAscending)
    {
        if (count($tableData) < 1)
            return $tableData;

        // Sort table?
        if ($sortColumn != -1)
        {
            if (count($tableData) > 0)
            {
                foreach ($tableData as $key => $row)
                {
                    $sortArray[$key]    = strtolower($row[$sortColumn]);
//                    $auflage[$key] = $row['Auflage'];       // Example to sort by 2nd parameter, keep it here!!
                }
                // Check for numeric sort
                $numericSort = false;
                if (isset($sortArray[0]) == true && isset($sortArray[1]) == true)
                {
                    // If the first two elements are numeric, we assume the column is numeric
                    if (is_numeric($sortArray[0]) == true && is_numeric($sortArray[1]) == true)
                        $numericSort = true;
                }
                if ($sortAscending == true)
                {
                    if ($numericSort == true)
                        array_multisort($sortArray, SORT_ASC, SORT_NUMERIC, $tableData);
                    else
                        array_multisort($sortArray, SORT_ASC, SORT_STRING, $tableData);
                }
                else
                {
                    if ($numericSort == true)
                        array_multisort($sortArray, SORT_DESC, SORT_NUMERIC, $tableData);
                    else
                        array_multisort($sortArray, SORT_DESC, SORT_STRING, $tableData);
                }
            }
        }

        return $tableData;
    }

    function send_mail($receiver, $title, $message, $sender)
    {
        global $MAIL_FOLDER;
        $cEmail = new cMail;

        return $cEmail->SendMailByParams($receiver, $title, $message, $sender, $MAIL_FOLDER);
    }

?>